<template>
  <div>

    <b-card
      no-body
      class="mb-0"
    >
      
      <b-form
        class="p-5"
        @submit.stop.prevent
      >
      <div class = "title">
        <h4>Registrar nueva actividad</h4>
      </div>
      <br>
        <b-alert variant="warning" :show="showAlert">Hay un campo vacio</b-alert>
        <b-alert variant="warning" :show="showAlertRequest">{{errorMessageRequest}}</b-alert>
          <b-form-group
            label="Nombre de la actividad"
            label-for="name"
            class="w-50"
          >
            <b-form-input
              id="name"
              v-model="formData.name"
              autofocus
              maxlength="50"
              trim
              :state="validationName"
              placeholder="Nombre de la actividad..."
            />
            <b-form-invalid-feedback :state="validationName">
                Este campo es obligatorio
            </b-form-invalid-feedback>                
                  
          </b-form-group>
          
          <b-form-group
              label="Descripción"
              label-for="description"
              class="w-50"
            >
              <b-form-input
                id="descrpition"
                v-model="formData.description"
                maxlength="150"
                autofocus
                trim
                :state="validationDescription"
                placeholder="Descripción de la actividad"
              />
              <b-form-invalid-feedback :state="validationDescription">
                  Este campo requieres 5 caracteres como mínimo
              </b-form-invalid-feedback>
                 
          </b-form-group>

          <b-form-group
              label="Seleccionar encargado de la actividad:"
              class="w-50"
            >
              <b-form-invalid-feedback :state="validationManager">
                  Es obligatorio esocger un encargado para la actividad
              </b-form-invalid-feedback>
              <b-form-select :state="validationManager" name="select-activitie-manager" v-model="formData.manager_id" class="mb-3" id="select-activitie-manager">
                <b-form-select-option :value="null" disabled>-- Por favor escoge un encargado --</b-form-select-option>
                <b-form-select-option v-for="(member,idx) in projectMembers" :key="idx" :value="member.id">{{member.name}} {{member.last_name}}</b-form-select-option>
              </b-form-select>

              
                   
          </b-form-group>

          <div class="d-flex mt-2">
            <b-button
              variant="primary"
              class="mr-2"
              type="submit"
              :disabled="lockedSubmitByDescription || lockedSubmitByName || lockedSubmitByManager || lockedSubmitBySubmit"
              @click="handleSubmit()"
            >
              Agregar
            </b-button>
            <b-button
              type="button"
              @click="$router.back()"
              variant="outline-secondary"    
            >
              Cancelar
            </b-button>
          </div>
      </b-form>
    </b-card>

  </div>
</template>

<script>
import {
  BSidebar, BForm, BFormGroup, BFormInput, BFormInvalidFeedback, BButton,BTab, BTabs, BCard, BAlert, BLink,BFormSelect,BFormSelectOption,
} from 'bootstrap-vue'


export default {
  components: {
    BTab,
    BTabs,
    BCard,
    BAlert,
    BLink,
    BSidebar,
    BForm,
    BFormGroup,
    BFormInput,
    BFormInvalidFeedback,
    BButton,
    BFormSelect,
    BFormSelectOption,

 
  },

  data(){
    return{
      formData:{
        name:'',
        description:'',
        manager_id:null,
        project_id:this.$route.params.id,


      },
      projectMembers:[],
      showAlert:false,
      showAlertRequest:false,
      hasWrittenName:false,
      hasWrittenDescription:false,
      errorMessageRequest:'',
      lockedSubmitByName:true,
      lockedSubmitByDescription:true,
      lockedSubmitByManager:true,
      lockedSubmitBySubmit:false,
      projectManager:''

    }
  },
  methods:{
    handleSubmit(){
      if(this.formData.name==='' || this.formData.description===''){
          this.showAlert=true
          return
      }else{
      this.$swal({          
          title: '¿Está seguro que desea agregar la actividad?',
          text: "Los detalles de la actividad pueden ser actualizados después",
          icon: 'warning',
          showCancelButton: true,
          confirmButtonText: 'Si, guardar!',
          customClass: {
            confirmButton: 'btn btn-primary',
            cancelButton: 'btn btn-outline-danger ml-1',
          },
          buttonsStyling: false,

        }).then(result => {
          if (result.value) {
            this.lockedSubmitBySubmit = true
            this.$http.post('project/activities/create',this.formData).then(res =>{
                
              if (res.data.message === "success") {
                this.$swal({
                          icon: 'success',
                          title: 'Guardada!',
                          text: 'La actividad fue agregada correctamente.',
                          customClass: {
                            confirmButton: 'btn btn-success',
                          },
                })
                this.$router.push({ name: 'apps-project-activities-view', params: { activitie: res.data.activitie,id: this.$route.params.id }} )

              }
              
                
         

            }).catch(err=>{
              if (err.response.status == 422){
                console.log('err')
                
                if (err.response.data.errors.rfc){
                  this.showAlertRequest = true
                  this.errorMessageRequest = err.response.data.errors.rfc[0]
                  console.log(err.response.data.errors.rfc[0])
                }
                if (err.response.data.errors.name){
                  this.showAlertRequest = true
                  this.errorMessageRequest = err.response.data.errors.name[0]
                  console.log(err.response.data.errors.name[0])
                }
              }
            })
            
            } else {
            this.$swal({
              title: 'Cancelado',
              text: 'La actividad no ha sido guardada',
              icon: 'error',
              customClass: {
                confirmButton: 'btn btn-success',
              },
            })
          }
        })
      }
            
    },
    getProjectMembers(){
      this.$http.get('project/activities/showProjectMembers',{params:{project:this.$route.params.id}}).then(res=>{
        this.projectMembers = res.data.members
      }).catch(err=>{
        console.log(err)
      })
    },
    getProjectManager(){
      this.$http.get('project/show',{params:{id:this.$route.params.id}}).then(res=>{
        this.projectManager = res.data.project.manager_id
        this.beforeEnter()
      }).catch(err=>{
        if (this.hasPermission('add_project_activities')) {
          return true
        }else {
          this.$router.push({name: "misc-not-authorized"}) 
        }
      })
    },
    beforeEnter(){
        let userData = JSON.parse(localStorage.userData)

        if ( this.hasPermission('add_project_activities') || userData.id === this.projectManager) {
          return true
        }else {
          this.$router.push({name: "misc-not-authorized"}) 
        }
        
    }
  },
  computed: {
      validationName() {
        if (this.formData.name.length > 0){
          this.hasWrittenName = true
        } 
        if(this.hasWrittenName){
          if(this.formData.name.length > 0){
            this.lockedSubmitByName = false
            return true
          }else{
            this.lockedSubmitByName = true
            return false
          }
          
        }
      },
      validationDescription(){
        if (this.formData.description.length > 0){
          this.hasWrittenDescription = true
        } 
        if(this.hasWrittenDescription){
          if(this.formData.description.length > 4){
            this.lockedSubmitByDescription = false
            return true
          }else{
            this.lockedSubmitByDescription = true
            return false
          }
          
        }
      },
      validationManager(){
        if (this.formData.manager_id != null){
          this.lockedSubmitByManager = false
          return true
        }else{
          this.lockedSubmitByManager = true
          return false
        }
        
      },
      
     
    },
    mounted(){
      this.getProjectMembers()
      this.getProjectManager()
    }



}
</script>

<style>

</style>
